with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ModuleDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 8, 13);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (58, 47, 21, 69);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (50, 46, 67, 24);

   G : constant array (0 .. 70) of Unsigned_8 :=
     (0, 0, 14, 32, 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 11, 0, 23, 13,
      5, 0, 0, 0, 26, 0, 0, 0, 0, 25, 8, 10, 19, 0, 0, 0, 0, 29, 21, 0, 2,
      12, 0, 0, 31, 0, 30, 0, 10, 0, 14, 4, 4, 0, 0, 3, 0, 0, 0, 1, 6, 0, 5,
      0, 26, 9, 13, 0, 22, 27);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 71;
         F2 := (F2 + Natural (T2 (K)) * J) mod 71;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 35;
   end Hash;

end CORBA_Repository_Root_ModuleDef_Hash;
